﻿  
CREATE PROCEDURE SStagin_InsertImportTrend
@TemplateName NVARCHAR(200)='',
@ImportFileName NVARCHAR(200)='',
@jsonTrend NVARCHAR(MAX),
@UserCreatedById UNIQUEIDENTIFIER	
AS
/*================================================================================    
Procedure Name: SStagin_InsertImportTrend    
Change History    
Date  Developer  Reason    
__________ ____________ ______________________________________________________    
05/04/2019 Praveen   Initial Version    
================================================================================*/ 
DECLARE @ImportId UNIQUEIDENTIFIER =NEWID()
declare @ErrorMsg NVARCHAR(2048),@CreatedOn Datetime
BEGIN
	SET @CreatedOn = GETDATE()
	BEGIN TRY   
	INSERT INTO ImportData
	(Id               , 
TemplateName		  ,
ImportFileName		  ,
--ImportStatusId		  ,
--ImportException		  ,
ImportedOn			  ,
UserImportedById)
VALUES(@ImportId, @TemplateName, @ImportFileName,@CreatedOn, @UserCreatedById)
---------------------------------------------------
INSERT INTO StaginTrend(Id               ,  
ImportId					  ,
Project						  ,
TrendName					  ,
Description					  ,
TrendStatus					  ,
Importance					  ,
ImpactDirection				  ,
TrendValue					  ,
Category					  ,
CompanyGroup				  ,
CompanyGroupImpact			  ,
CompanyGroupEndUser			  ,
Company						  ,
Country						  ,
CountryImpact				  ,
CountryEndUser				  ,
EcoSystem					  ,
EcoSystemImpact				  ,
EcoSystemEndUser			  ,
TrendKeyWord				  ,
Industry					  ,
IndustryImpact				  ,
IndustryEndUser				  ,
Market						  ,
Region						  ,
RegionImpact				  ,
RegionEndUser				  ,
MarketImpact				  ,
MarketEndUser				  ,
Project1					  ,
ProjectImpact				  ,
ProjectEndUser				  ,
StrengthtType				  ,
StrengthDescription			  ,
WeaknessType				  ,
WeaknessDescription			  ,
OpportunityType				  ,
OpportunityDescription		  ,
ThreatType					  ,
ThreatDescription			  ,
TimeTag						  ,
TimeTagImpact				  ,
TimeTagEndUser				  ,
ValueConversion				  ,
Rationale_2018		  ,
Value_2018		  ,
Rationale_2019			  ,
Value_2019			  ,
Rationale_2020			  ,
Value_2020			  ,
Rationale_2021			  ,
Value_2021			  ,
Rationale_2022			  ,
Value_2022			  ,
Rationale_2023			  ,
Value_2023			  ,
Rationale_2024			  ,
Value_2024			  ,
Rationale_2025			  ,
Value_2025			  ,
Rationale_2026			  ,
Value_2026			  ,
Rationale_2027			  ,
Value_2027			  ,
Rationale_2028			  ,
Value_2028			  ,
Rationale_2029			  ,
Value_2029			  ,
Rationale_2030			  ,
Value_2030			  ,
Rationale_2031			  ,
Value_2031			  ,
Rationale_2032			  ,
Value_2032			  ,
CompanyGroup_ApproverRemark	  ,
CompanyGroup_AuthorRemark	  ,
CompanyGroup_TrendStatus	  ,
EcoSystem_ApproverRemark	  ,
EcoSystem_AuthorRemark		  ,
EcoSystem_TrendStatus		  ,
Industry_ApproverRemark		  ,
Industry_AuthorRemark		  ,
Industry_TrendStatus		  ,
KeyCompany_ApproverRemark	  ,
KeyCompany_AuthorRemark		  ,
KeyCompany_TrendStatus		  ,
keyword_ApproverRemark		  ,
keyword_AuthorRemark		  ,
keyword_TrendStatus			  ,
Market_ApproverRemark		  ,
Market_AuthorRemark			  ,
Market_TrendStatus			  ,
Project_ApproverRemark		  ,
Project_AuthorRemark		  ,
Project_TrendStatus			  ,
Region_ApproverRemark		  ,
Region_AuthorRemark			  ,
Region_TrendStatus			  ,
TimeTag_ApproverRemark		  ,
TimeTag_AuthorRemark		  ,
TimeTag_TrendStatus			  ,
Value_ApproverRemark		  ,
Value_AuthorRemark			  ,
Value_TrendStatus)
SELECT
       NEWID()               ,  
@ImportId					  ,
Project						  ,
TrendName					  ,
Description					  ,
TrendStatus					  ,
Importance					  ,
ImpactDirection				  ,
TrendValue					  ,
Category					  ,
CompanyGroup				  ,
CompanyGroupImpact			  ,
CompanyGroupEndUser			  ,
Company						  ,
Country						  ,
CountryImpact				  ,
CountryEndUser				  ,
EcoSystem					  ,
EcoSystemImpact				  ,
EcoSystemEndUser			  ,
TrendKeyWord				  ,
Industry					  ,
IndustryImpact				  ,
IndustryEndUser				  ,
Market						  ,
Region						  ,
RegionImpact				  ,
RegionEndUser				  ,
MarketImpact				  ,
MarketEndUser				  ,
Project1					  ,
ProjectImpact				  ,
ProjectEndUser				  ,
StrengthtType				  ,
StrengthDescription			  ,
WeaknessType				  ,
WeaknessDescription			  ,
OpportunityType				  ,
OpportunityDescription		  ,
ThreatType					  ,
ThreatDescription			  ,
TimeTag						  ,
TimeTagImpact				  ,
TimeTagEndUser				  ,
ValueConversion				  ,
Rationale_2018				  ,
Value_2018					  ,
Rationale_2019					  ,
Value_2019						  ,
Rationale_2020					  ,
Value_2020						  ,
Rationale_2021					  ,
Value_2021						  ,
Rationale_2022					  ,
Value_2022						  ,
Rationale_2023					  ,
Value_2023						  ,
Rationale_2024					  ,
Value_2024					  ,
Rationale_2025					  ,
Value_2025						  ,
Rationale_2026					  ,
Value_2026						  ,
Rationale_2027					  ,
Value_2027						  ,
Rationale_2028					  ,
Value_2028						  ,
Rationale_2029					  ,
Value_2029						  ,
Rationale_2030					  ,
Value_2030						  ,
Rationale_2031					  ,
Value_2031						  ,
Rationale_2032					  ,
Value_2032						  ,
CompanyGroup_ApproverRemark	  ,
CompanyGroup_AuthorRemark	  ,
CompanyGroup_TrendStatus	  ,
EcoSystem_ApproverRemark	  ,
EcoSystem_AuthorRemark		  ,
EcoSystem_TrendStatus		  ,
Industry_ApproverRemark		  ,
Industry_AuthorRemark		  ,
Industry_TrendStatus		  ,
KeyCompany_ApproverRemark	  ,
KeyCompany_AuthorRemark		  ,
KeyCompany_TrendStatus		  ,
keyword_ApproverRemark		  ,
keyword_AuthorRemark		  ,
keyword_TrendStatus			  ,
Market_ApproverRemark		  ,
Market_AuthorRemark			  ,
Market_TrendStatus			  ,
Project_ApproverRemark		  ,
Project_AuthorRemark		  ,
Project_TrendStatus			  ,
Region_ApproverRemark		  ,
Region_AuthorRemark			  ,
Region_TrendStatus			  ,
TimeTag_ApproverRemark		  ,
TimeTag_AuthorRemark		  ,
TimeTag_TrendStatus			  ,
Value_ApproverRemark		  ,
Value_AuthorRemark			  ,
Value_TrendStatus
    FROM OPENJSON(@jsonTrend)
    WITH (      
	[Project] [nvarchar](255) ,
	[TrendName] [nvarchar](255) ,
	[Description] [nvarchar](255) ,
	[TrendStatus] [nvarchar](255) ,
	[Importance] [nvarchar](255) ,
	[ImpactDirection] [nvarchar](255) ,
	[TrendValue] [nvarchar](255) ,
	[Category] [nvarchar](255) ,
	[CompanyGroup] [nvarchar](255) ,
	[CompanyGroupImpact] [nvarchar](255) ,
	[CompanyGroupEndUser] [nvarchar](255) ,
	[Company] [nvarchar](255) ,
	[Country] [nvarchar](255) ,
	[CountryImpact] [nvarchar](255) ,
	[CountryEndUser] [nvarchar](255) ,
	[EcoSystem] [nvarchar](255) ,
	[EcoSystemImpact] [nvarchar](255) ,
	[EcoSystemEndUser] [nvarchar](255) ,
	[TrendKeyWord] [nvarchar](255) ,
	[Industry] [nvarchar](255) ,
	[IndustryImpact] [nvarchar](255) ,
	[IndustryEndUser] [nvarchar](255) ,
	[Market] [nvarchar](255) ,
	[Region] [nvarchar](255) ,
	[RegionImpact] [nvarchar](255) ,
	[RegionEndUser] [nvarchar](255) ,
	[MarketImpact] [nvarchar](255) ,
	[MarketEndUser] [nvarchar](255) ,
	[Project1] [nvarchar](255) ,
	[ProjectImpact] [nvarchar](255) ,
	[ProjectEndUser] [nvarchar](255) ,
	[StrengthtType] [nvarchar](255) ,
	[StrengthDescription] [nvarchar](255) ,
	[WeaknessType] [nvarchar](255) ,
	[WeaknessDescription] [nvarchar](255) ,
	[OpportunityType] [nvarchar](255) ,
	[OpportunityDescription] [nvarchar](255) ,
	[ThreatType] [nvarchar](255) ,
	[ThreatDescription] [nvarchar](255) ,
	[TimeTag] [nvarchar](255) ,
	[TimeTagImpact] [nvarchar](255) ,
	[TimeTagEndUser] [nvarchar](255) ,
	[ValueConversion] [nvarchar](255) ,
	[Rationale_2018] [nvarchar](255) ,
	[Value_2018] [nvarchar](255) ,
	[Rationale_2019] [nvarchar](255) ,
	[Value_2019] [nvarchar](255) ,
	[Rationale_2020] [nvarchar](255) ,
	[Value_2020] [nvarchar](255) ,
	[Rationale_2021] [nvarchar](255) ,
	[Value_2021] [nvarchar](255) ,
	[Rationale_2022] [nvarchar](255) ,
	[Value_2022] [nvarchar](255) ,
	[Rationale_2023] [nvarchar](255) ,
	[Value_2023] [nvarchar](255) ,
	[Rationale_2024] [nvarchar](255) ,
	[Value_2024] [nvarchar](255) ,
	[Rationale_2025] [nvarchar](255) ,
	[Value_2025] [nvarchar](255) ,
	[Rationale_2026] [nvarchar](255) ,
	[Value_2026] [nvarchar](255) ,
	[Rationale_2027] [nvarchar](255) ,
	[Value_2027] [nvarchar](255) ,
	[Rationale_2028] [nvarchar](255) ,
	[Value_2028] [nvarchar](255) ,
	[Rationale_2029] [nvarchar](255) ,
	[Value_2029] [nvarchar](255) ,
	[Rationale_2030] [nvarchar](255) ,
	[Value_2030] [nvarchar](255) ,
	[Rationale_2031] [nvarchar](255) ,
	[Value_2031] [nvarchar](255) ,
	[Rationale_2032] [nvarchar](255) ,
	[Value_2032] [nvarchar](255)  ,
	[CompanyGroup_ApproverRemark] [nvarchar](max) ,
	[CompanyGroup_AuthorRemark] [nvarchar](max) ,
	[CompanyGroup_TrendStatus] [nvarchar](255) ,
	[EcoSystem_ApproverRemark] [nvarchar](max) ,
	[EcoSystem_AuthorRemark] [nvarchar](max)  ,
	[EcoSystem_TrendStatus] [nvarchar](255) ,
	[Industry_ApproverRemark] [nvarchar](max) ,
	[Industry_AuthorRemark] [nvarchar](max) ,
	[Industry_TrendStatus] [nvarchar](255) ,
	[KeyCompany_ApproverRemark] [nvarchar](max) ,
	[KeyCompany_AuthorRemark] [nvarchar](max) ,
	[KeyCompany_TrendStatus] [nvarchar](255) ,
	[keyword_ApproverRemark] [nvarchar](max) ,
	[keyword_AuthorRemark] [nvarchar](max) ,
	[keyword_TrendStatus] [nvarchar](255) ,
	[Market_ApproverRemark] [nvarchar](max) ,
	[Market_AuthorRemark] [nvarchar](max) ,
	[Market_TrendStatus] [nvarchar](255) ,
	[Project_ApproverRemark] [nvarchar](max) ,
	[Project_AuthorRemark] [nvarchar](max) ,
	[Project_TrendStatus] [nvarchar](255) ,
	[Region_ApproverRemark] [nvarchar](max) ,
	[Region_AuthorRemark] [nvarchar](max) ,
	[Region_TrendStatus] [nvarchar](255) ,
	[TimeTag_ApproverRemark] [nvarchar](max) ,
	[TimeTag_AuthorRemark] [nvarchar](max) ,
	[TimeTag_TrendStatus] [nvarchar](255) ,
	[Value_ApproverRemark] [nvarchar](max) ,
	[Value_AuthorRemark] [nvarchar](max)  ,
	[Value_TrendStatus] [nvarchar](255) 
    ) AS jsonTrends
 

 SELECT StoredProcedureName ='SStagin_InsertImportTrend',Message =@ErrorMsg,Success = 1;   
END TRY    
BEGIN CATCH    
    -- Execute the error retrieval routine.    
 DECLARE @ErrorNumber int;    
 DECLARE @ErrorSeverity int;    
 DECLARE @ErrorProcedure varchar;    
 DECLARE @ErrorLine int;    
 DECLARE @ErrorMessage varchar;    
    
  SELECT @ErrorNumber = ERROR_NUMBER(),    
        @ErrorSeverity = ERROR_SEVERITY(),    
        @ErrorProcedure = ERROR_PROCEDURE(),    
        @ErrorLine = ERROR_LINE(),    
        @ErrorMessage = ERROR_MESSAGE()    
    
 insert into dbo.Errorlog(ErrorNumber,    
       ErrorSeverity,    
       ErrorProcedure,    
       ErrorLine,    
       ErrorMessage,    
       ErrorDate)    
        values(@ErrorNumber,@ErrorSeverity,@ErrorProcedure,@ErrorLine,@ErrorMessage,@CreatedOn);    
  
 set @ErrorMsg = 'Error while importing trend, please contact Admin for more details.';    
--THROW 50000,@ErrorMsg,1;      
--return(1)  
SELECT Number = @ErrorNumber, Severity =@ErrorSeverity,StoredProcedureName =@ErrorProcedure,LineNumber= @ErrorLine  
    ,Message =@ErrorMsg,Success = 0;     
     
END CATCH     


END